<!-- eslint-disable vue/no-mutating-props -->
<template>
  <div>
    <b-alert
      v-model="errored"
      class="mb-2"
      variant="danger"
    >
      There was an error loading search dimensions and you will not be able to filter loci. Please
      refresh the page to try again and, if the problem persists, contact us at
      {{ ANTARES_SUPPORT_EMAIL }}:
      <pre class="mt-2">{{ JSON.stringify(errorMessage, null, 2) }}</pre>
    </b-alert>
    <b-form @submit.prevent="$emit('apply-filters', buildFilters())">
      <b-form-group
        v-if="filters.length > 0"
        label="Active Filters"
      >
        <b-list-group>
          <b-list-group-item
            v-for="(filter, index) in filters"
            :key="index"
            class="active-filter align-items-center d-flex"
            variant="warning"
          >
            <b-button
              class="h-100 text-dark"
              size="sm"
              squared
              variant="link"
              @click="$emit('remove-filter', index)"
            >
              <font-awesome-icon icon="times" />
            </b-button>
            {{ filter.text }}
          </b-list-group-item>
        </b-list-group>
      </b-form-group>
      <b-form-group
        v-if="
          !filters.filter((f) => f.field == 'properties.newest_alert_observation_time').length
        "
        label="Latest Alert Within"
      >
        <b-form-select
          v-model="newestAlertObservationTimeRange"
          :disabled="disabled || errored"
          :options="timeRangeOptions"
          @change="canApplyFilters = true"
        />
        <div
          v-if="newestAlertObservationTimeRange === TimeRange.CUSTOM_RANGE"
          class="align-items-baseline d-flex mt-2"
        >
          <label class="flex-shrink-0 mr-2 small">Min MJD:</label>
          <b-form-input
            v-model.number="newestAlertObservationTimeRangeMjd.min"
            :disabled="disabled || errored"
            class="flex-shrink-1 mr-2"
            style="min-width: 0"
          />
          <label class="flex-shrink-0 mr-2 small">Max MJD:</label>
          <b-form-input
            v-model.number="newestAlertObservationTimeRangeMjd.max"
            :disabled="disabled || errored"
            class="flex-shrink-1"
            style="min-width: 0"
          />
        </div>
      </b-form-group>
      <b-form-group
        v-if="
          !filters.filter((f) => f.field == 'properties.oldest_alert_observation_time').length
        "
        label="First Alert Within"
      >
        <b-form-select
          v-model="oldestAlertObservationTimeRange"
          :disabled="disabled || errored"
          :options="timeRangeOptions"
          @change="canApplyFilters = true"
        />
        <div
          v-if="oldestAlertObservationTimeRange === TimeRange.CUSTOM_RANGE"
          class="align-items-baseline d-flex mt-2"
        >
          <label class="flex-shrink-0 mr-2 small">Min MJD:</label>
          <b-form-input
            v-model.number="oldestAlertObservationTimeRangeMjd.min"
            :disabled="disabled || errored"
            class="flex-shrink-1 mr-2"
            style="min-width: 0"
          />
          <label class="flex-shrink-0 mr-2 small">Max MJD:</label>
          <b-form-input
            v-model.number="oldestAlertObservationTimeRangeMjd.max"
            :disabled="disabled || errored"
            class="flex-shrink-1"
            style="min-width: 0"
          />
        </div>
      </b-form-group>
      <b-form-group
        v-show="numMeasurementsBounds[0] !== numMeasurementsBounds[1]"
        label="Number of Measurements"
      >
        <base-slider-range
          ref="BaseSliderRange"
          v-model="numMeasurementsRange"
          :disabled="disabled || errored"
          :max="numMeasurementsBounds[1]"
          :min="numMeasurementsBounds[0]"
          @input="canApplyFilters = true"
        />
      </b-form-group>
      <b-form-group label="Cone Search">
        <div class="d-flex align-items-baseline">
          <label class="mr-2 small">Center: </label>
          <b-form-input
            id="input-cone-search-center"
            v-model="coneSearch.center"
            :disabled="disabled || errored"
            class="mb-1 flex-shrink-1"
            placeholder="Enter a coordinate string"
            style="overflow: hidden; text-overflow: ellipsis"
            size="sm"
            @input="canApplyFilters = true"
          />
          <b-tooltip
            custom-class="tooltip-wide tooltip-text-left"
            no-fade
            placement="right"
            target="#input-cone-search-center"
            variant="primary"
          >
            <span class="mb-2">These examples of accepted formats are equivalent:</span>
            <ul class="font-italic list-unstyled mt-2 mb-0">
              <li>90.00 0.00</li>
              <li>90d 0d</li>
              <li>90d00 0d00</li>
              <li>90d00m00.00s 00d00m00.00s</li>
              <li>06:00:00 00:00:00</li>
              <li>06:00:00 +00:00:00</li>
            </ul>
          </b-tooltip>
        </div>
        <div class="d-flex align-items-baseline">
          <label class="mr-2 small">Radius: </label>
          <b-form-input
            v-model="coneSearch.radius"
            :disabled="disabled || errored"
            class="mr-1"
            size="sm"
            style="overflow: hidden; text-overflow: ellipsis"
          />
          <b-form-select
            v-model="coneSearch.radiusUnit"
            :options="coneSearch.radiusUnitOptions"
            size="sm"
          />
        </div>
      </b-form-group>
      <b-form-group
        v-if="catalogOptions.length"
        label="Catalogs"
      >
        <b-form-select
          v-model="selectedCatalogs"
          :disabled="disabled || errored"
          :options="catalogOptions"
          :select-size="10"
          multiple
          @change="canApplyFilters = true"
        />
      </b-form-group>
      <b-form-group
        v-if="tagOptions.length"
        label="Tags"
      >
        <b-form-select
          v-model="selectedTags"
          :disabled="disabled || errored"
          :options="tagOptions"
          :select-size="10"
          multiple
          @change="canApplyFilters = true"
        />
      </b-form-group>
      <b-form-group>
        <template #label>
          Gravitational wave event ID
          <span
            v-b-tooltip.hover.right.v-primary
            title="Filter loci associated to a specific GraceDB ID"
          >
            <font-awesome-icon icon="question-circle" />
          </span>
        </template>
        <b-form-input
          v-model="gravWaveEventId"
          :disabled="disabled || errored"
          class="grav-wave-event-id-input"
          @input="onGravWaveEventIdInput"
        />
      </b-form-group>
      <b-button
        v-if="canApplyFilters"
        block
        type="submit"
        variant="primary"
      >
        Apply Filters
      </b-button>
    </b-form>
  </div>
</template>

<script lang="ts">
/* eslint-disable camelcase, no-shadow, no-return-assign, eqeqeq */
import Vue, { PropType } from 'vue';
import { mapGetters } from 'vuex';
import { base as astronomia, julian } from 'astronomia';
import { ElasticsearchFilter } from '@/common/types';
import BaseSliderRange from '@/components/BaseSliderRange.vue';

enum TimeRange {
  LAST_DAY = 'LAST_DAY',
  LAST_WEEK = 'LAST_WEEK',
  LAST_MONTH = 'LAST_MONTH',
  LAST_YEAR = 'LAST_YEAR',
  ALL_TIME = 'ALL_TIME',
  CUSTOM_RANGE = 'CUSTOM_RANGE',
}

export default Vue.extend({
  components: {
    BaseSliderRange,
  },

  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false,
    },
    errored: {
      type: Boolean,
      required: false,
      default: false,
    },
    errorMessage: {
      type: String,
      required: false,
      default: '',
    },
    filters: {
      required: true,
      type: Array as PropType<ElasticsearchFilter[]>,
    },
  },

  data() {
    return {
      TimeRange,
      canApplyFilters: false,
      coneSearch: {
        center: '',
        radius: 1.0,
        radiusUnit: 'arcsec',
        radiusUnitOptions: ['arcsec', 'arcmin'],
      },
      gravWaveEventId: '',
      newestAlertObservationTimeRange: TimeRange.ALL_TIME,
      newestAlertObservationTimeRangeMjd: {
        max: null as number | null,
        min: null as number | null,
      },
      csDenominator: 1.0,
      numMeasurementsBounds: [1, 100],
      numMeasurementsRange: [1, 100],
      oldestAlertObservationTimeRange: TimeRange.ALL_TIME,
      oldestAlertObservationTimeRangeMjd: {
        max: null as number | null,
        min: null as number | null,
      },
      selectedCatalogs: [],
      selectedTags: [],
      timeRangeOptions: [
        { value: TimeRange.LAST_DAY, text: 'Last day' },
        { value: TimeRange.LAST_WEEK, text: 'Last week' },
        { value: TimeRange.LAST_MONTH, text: 'Last month' },
        { value: TimeRange.LAST_YEAR, text: 'Last year' },
        { value: TimeRange.ALL_TIME, text: 'All time' },
        { value: TimeRange.CUSTOM_RANGE, text: 'Custom range' },
      ],
    };
  },

  computed: {
    ...mapGetters(['lociStatistics']),
    catalogOptions(): { value: string; html: string }[] {
      if (this.lociStatistics) {
        return Object.entries(this.lociStatistics.catalogs).map(([key, value]) => ({
          value: key,
          html: `
                <div class="d-flex">
                  <span class="mr-1" style="overflow: hidden; text-overflow: ellipsis">${key}</span>
                  <span>(${this.formatNumber(value, 1)})</span>
                </div>
            `,
        }));
      }
      return [];
    },

    gravWaveEventsFilters(): ElasticsearchFilter[] {
      return this.filters.filter(({ field }) => field === 'grav_wave_events.keyword');
    },

    tagOptions(): { value: string; html: string }[] {
      if (this.lociStatistics) {
        return Object.entries(this.lociStatistics.tags).map(([key, value]) => ({
          value: key,
          html: `
                <div class="d-flex">
                  <span class="mr-1" style="overflow: hidden; text-overflow: ellipsis">${key}</span>
                  <span>(${this.formatNumber(value, 1)})</span>
                </div>
            `,
        }));
      }
      return [];
    },
  },

  watch: {
    filters() {
      this.canApplyFilters = false;
      this.gravWaveEventId = '';
      this.selectedCatalogs = [];
      this.selectedTags = [];
      this.coneSearch.center = '';
      this.coneSearch.radius = 1.0;
      this.oldestAlertObservationTimeRangeMjd = {
        max: null,
        min: null,
      };
      this.newestAlertObservationTimeRangeMjd = {
        max: null,
        min: null,
      };
    },

    lociStatistics: {
      immediate: true,
      handler() {
        if (this.lociStatistics) {
          const {
            max_num_measurements: maxNumMeasurements,
            min_num_measurements: minNumMeasurements,
          } = this.lociStatistics;
          this.$nextTick(() => {
            (<any> this.$refs.BaseSliderRange).set(minNumMeasurements, maxNumMeasurements);
            this.canApplyFilters = false;
            this.$nextTick(
              () => (this.numMeasurementsBounds = [minNumMeasurements, maxNumMeasurements]),
            );
          });
        }
      },
    },

    newestAlertObservationTimeRange: {
      immediate: true,
      handler(val) {
        if (val === TimeRange.LAST_DAY) {
          const date = new Date();
          date.setDate(date.getDate() - 1);
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_WEEK) {
          const date = new Date();
          date.setDate(date.getDate() - 7);
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_MONTH) {
          const date = new Date();
          date.setMonth(date.getMonth() - 1);
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_YEAR) {
          const date = new Date();
          date.setFullYear(date.getFullYear() - 1);
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.ALL_TIME) {
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: null,
          };
        } else if (val === TimeRange.CUSTOM_RANGE) {
          this.newestAlertObservationTimeRangeMjd = {
            max: null,
            min: null,
          };
        }
      },
    },
    oldestAlertObservationTimeRange: {
      immediate: true,
      handler(val) {
        if (val === TimeRange.LAST_DAY) {
          const date = new Date();
          date.setDate(date.getDate() - 1);
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_WEEK) {
          const date = new Date();
          date.setDate(date.getDate() - 7);
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_MONTH) {
          const date = new Date();
          date.setMonth(date.getMonth() - 1);
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.LAST_YEAR) {
          const date = new Date();
          date.setFullYear(date.getFullYear() - 1);
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: julian.DateToJD(date) - astronomia.JMod,
          };
        } else if (val === TimeRange.ALL_TIME) {
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: null,
          };
        } else if (val === TimeRange.CUSTOM_RANGE) {
          this.oldestAlertObservationTimeRangeMjd = {
            max: null,
            min: null,
          };
        }
      },
    },
  },

  methods: {
    buildFilters() {
      const filters = [];

      // Build newest alert filter
      if (
        this.newestAlertObservationTimeRangeMjd.max
        || this.newestAlertObservationTimeRangeMjd.min
      ) {
        let text = '';
        if (
          this.newestAlertObservationTimeRangeMjd.max
          && this.newestAlertObservationTimeRangeMjd.min
        ) {
          text = `Latest alert in MJD range (${this.newestAlertObservationTimeRangeMjd.min.toFixed(
            2,
          )}, ${this.newestAlertObservationTimeRangeMjd.max.toFixed(2)})`;
        } else if (this.newestAlertObservationTimeRangeMjd.max) {
          text = `Latest alert before MJD ${this.newestAlertObservationTimeRangeMjd.max.toFixed(
            2,
          )}`;
        } else if (this.newestAlertObservationTimeRangeMjd.min) {
          text = `Latest alert after MJD ${this.newestAlertObservationTimeRangeMjd.min.toFixed(2)}`;
        }
        filters.push({
          type: 'range',
          field: 'properties.newest_alert_observation_time',
          value: {
            ...(this.newestAlertObservationTimeRangeMjd.max && {
              lte: this.newestAlertObservationTimeRangeMjd.max,
            }),
            ...(this.newestAlertObservationTimeRangeMjd.min && {
              gte: this.newestAlertObservationTimeRangeMjd.min,
            }),
          },
          options: {},
          text,
        });
      }

      // Build oldest Alert filter
      if (
        this.oldestAlertObservationTimeRangeMjd.max
        || this.oldestAlertObservationTimeRangeMjd.min
      ) {
        let text = '';
        if (
          this.oldestAlertObservationTimeRangeMjd.max
          && this.oldestAlertObservationTimeRangeMjd.min
        ) {
          text = `First alert in MJD range (${this.oldestAlertObservationTimeRangeMjd.min.toFixed(
            2,
          )}, ${this.oldestAlertObservationTimeRangeMjd.max.toFixed(2)})`;
        } else if (this.oldestAlertObservationTimeRangeMjd.max) {
          text = `First alert before MJD ${this.oldestAlertObservationTimeRangeMjd.max.toFixed(2)}`;
        } else if (this.oldestAlertObservationTimeRangeMjd.min) {
          text = `First alert after MJD ${this.oldestAlertObservationTimeRangeMjd.min.toFixed(2)}`;
        }
        filters.push({
          type: 'range',
          field: 'properties.oldest_alert_observation_time',
          value: {
            ...(this.oldestAlertObservationTimeRangeMjd.max && {
              lte: this.oldestAlertObservationTimeRangeMjd.max,
            }),
            ...(this.oldestAlertObservationTimeRangeMjd.min && {
              gte: this.oldestAlertObservationTimeRangeMjd.min,
            }),
          },
          options: {},
          text,
        });
      }

      // Build less complicated filters
      if (this.numMeasurementsRange[0] != this.numMeasurementsBounds[0]) {
        filters.push({
          type: 'range',
          field: 'properties.num_mag_values',
          value: {
            gte: this.numMeasurementsRange[0],
          },
          options: {},
          text: `>= ${this.numMeasurementsRange[0]} measurements`,
        });
      }
      if (this.numMeasurementsRange[1] != this.numMeasurementsBounds[1]) {
        filters.push({
          type: 'range',
          field: 'properties.num_mag_values',
          value: {
            lte: this.numMeasurementsRange[1],
          },
          options: {},
          text: `<= ${this.numMeasurementsRange[1]} measurements`,
        });
      }
      if (this.selectedCatalogs.length) {
        filters.push({
          type: 'terms',
          field: 'catalogs',
          value: this.selectedCatalogs,
          options: {},
          text: `Catalogs: ${this.selectedCatalogs.join(' OR ')}`,
        });
      }
      if (this.selectedTags.length) {
        filters.push({
          type: 'terms',
          field: 'tags',
          value: this.selectedTags,
          options: {},
          text: `Tags: ${this.selectedTags.join(' OR ')}`,
        });
      }
      if (this.gravWaveEventId) {
        filters.push({
          type: 'wildcard',
          field: 'grav_wave_events.keyword',
          value: `${this.gravWaveEventId}*`,
          text: `GraceDB ID: ${this.gravWaveEventId}`,
        });
      }
      if (this.coneSearch.center) {
        if (this.coneSearch.radiusUnit == 'arcmin') {
          this.csDenominator = 60.0;
        } else {
          this.csDenominator = 3600.0;
        }
        filters.push({
          type: 'sky_distance',
          field: {
            distance: `${this.coneSearch.radius / this.csDenominator} degree`,
            htm16: {
              center: this.coneSearch.center,
            },
          },
          text: `Cone Search: ${this.coneSearch.center}, ${this.coneSearch.radius}"`,
        });
      }
      return filters;
    },

    onGravWaveEventIdInput(input: string) {
      const filtersValues = this.gravWaveEventsFilters.map(({ value }) => value.slice(0, -1));
      if (filtersValues.includes(input)) {
        this.canApplyFilters = false;
        return;
      }
      this.canApplyFilters = true;
    },
  },
});
</script>

<style scoped>
.form-group {
  margin-bottom: 1em;
}

.active-filter {
  padding: 0.2em 0.2em;
}
</style>
